
----------- [ Config ] --------

-- Main addon object containing AceEvent
-- We assume you have OBJ:SAVE() and OBJ:LOAD!
local addon_object = MPS

-- When to run as slave.
local SLAVE_PRIO = 2
local SLAVE_NAME = "Macros"
-------------------------------





-- Globals
if not Profiles_global_que then
	Profiles_global_que = {}
end

local Profiles_global_que_copy = {}



if not Profiles_master_flag then
	Profiles_master_flag = {}
end
	
-- Register with the Global Profiles Que
Profiles_global_que[SLAVE_PRIO] = SLAVE_NAME

-- Wait for master to call my Slave_controller() (Register event SLAVE_NAME)
-- Look for this command at the bottom of this file

-- Broadcast if master, report action done if slave
function addon_object:SendAceMsg(...)
	
	-- action = "save"/profile_name = "test"
	local action,profile_name = ...
	
	-- No one has claimed master! Claim it!
	if Profiles_master_flag[name] == nil then
		
		-- Profiles_global_que_copy = Profiles_global_que 
		-- Is not a local copy....
		for prio,slave in pairs(Profiles_global_que) do
			Profiles_global_que_copy[prio] = slave
		end
		
		Profiles_master_flag = 
		{
			name = SLAVE_NAME,
			master_action = action,
			master_profile_name = profile_name,
		}
		
		addon_object:Master_controller()
	else
		return -- I am slave: Blocked outgoing messages
	end
end

function addon_object:Master_controller(...)
	
	-- Fix padding in global que (for ipairs)
	-- [1]: addon1 [2]: nil [3]: addon2 -> [1]: addon1 [2]: 1 [3]: addon2
	for i=1,getn(Profiles_global_que) do
		if not Profiles_global_que_copy[i] then
			Profiles_global_que_copy[i] = 1
		end
	end
		
	print("MASTER: "..SLAVE_NAME,Profiles_global_que_copy[1],Profiles_global_que_copy[2],Profiles_global_que_copy[3],Profiles_master_flag.name,Profiles_master_flag.master_action,Profiles_master_flag.master_profile_name)
	
	-- Get ready for slaves, when slave is done he will call Master_controller() again
	addon_object:RegisterMessage("Profiles_Master_controller","Master_controller")
			
	
	-- Proccess slaves
	for prio,slave in ipairs(Profiles_global_que_copy) do
		if slave ~= 1 then
			-- Mark slave as done
			Profiles_global_que_copy[prio] = 1 
			
			-- Command slave to do masters action
			-- slave = "Macros"
			
			print(SLAVE_NAME.." Proccessing.."..slave)
			addon_object:SendMessage(slave)
			return
		end
	end
	
	-- All slaves are done
	addon_object:UnregisterMessage("Profiles_Master_controller")
	addon_object:Echo(SLAVE_NAME.." master done!")
	Profiles_master_flag = 
	{
		name = nil,
		master_action = nil,
		master_profile_name = nil,
	}
end

function addon_object:Slave_controller(...)
	
print("SLAVE: "..SLAVE_NAME,Profiles_global_que_copy[1],Profiles_global_que_copy[2],Profiles_global_que_copy[3],Profiles_master_flag.name,Profiles_master_flag.master_action,Profiles_master_flag.master_profile_name)
	if Profiles_master_flag.master_action == "save" then
		addon_object:Save(Profiles_master_flag.master_profile_name)
	end
	
	if Profiles_master_flag.master_action == "load" then
		addon_object:Load(Profiles_master_flag.master_profile_name)
	end
	
	-- Report back to master, done with actions
	addon_object:SendMessage("Profiles_Master_controller")
end

-- Wait for master to call my Slave_controller() (Register event SLAVE_NAME)
addon_object:RegisterMessage(SLAVE_NAME,"Slave_controller",SLAVE_NAME)